SystemOrganization addCategory: #ConfigurationOfA4BPonMoose!

Object subclass: #ConfigurationOfA4BPonMoose
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfA4BPonMoose'!

!ConfigurationOfA4BPonMoose commentStamp: 'AlvaroJosePeraltaOcampo 4/28/2016 19:02' prior: 0!
Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State a one line summary. For example, "I represent a paragraph of text".

For the Responsibility part: Three sentences about my main responsibilities - what I do, what I know.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	project:		A4BP on commit


    Implementation Points!

!ConfigurationOfA4BPonMoose class methodsFor: 'development support' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 18:52'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>! !

!ConfigurationOfA4BPonMoose class methodsFor: 'private' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 18:52'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #'ConfigurationOf'
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #'ConfigurationOf' ifAbsent: aBlock ].! !

!ConfigurationOfA4BPonMoose class methodsFor: 'private' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 18:52'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfA4BPonMoose class methodsFor: 'private' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 18:52'!
ensureMetacelloBaseConfiguration
  Smalltalk
    at: #'ConfigurationOf'
    ifAbsent: [ 
      | repository version |
      repository := MCHttpRepository
        location: 'http://smalltalkhub.com/mc/dkh/metacello/main'
        user: ''
        password: ''.
      repository
        versionReaderForFileNamed: 'Metacello-Base-dkh.107'
        do: [ :reader | 
          version := reader version.
          version load.
          version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfA4BPonMoose class methodsFor: 'metacello tool support' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 18:52'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfA4BPonMoose class methodsFor: 'loading' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 18:52'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfA4BPonMoose class methodsFor: 'loading' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 18:52'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfA4BPonMoose class methodsFor: 'loading' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 18:52'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfA4BPonMoose class methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 18:52'!
project

	^self new project! !

!ConfigurationOfA4BPonMoose class methodsFor: 'development support' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 18:52'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfA4BPonMoose methodsFor: 'baselines' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 18:57'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec 
			project: 'A4BP' with: [
				spec
					className: #ConfigurationOfA4BP;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo50/main/' ];
			project: 'Moose' with: [
				spec
					className: #ConfigurationOfMoose;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/Moose/Moose/main/' ].
		spec 
			package: 'AgentOrganizationEvaluation-A4BP' with: [
				spec requires: #('AgentOrganizationEvaluation-Model' 'A4BP' 'Moose' ). ];
			package: 'AgentOrganizationEvaluation-Model' with: [
				spec requires: #('Moose' ). ]. ].
! !

!ConfigurationOfA4BPonMoose methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 18:52'!
customProjectAttributes
    "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes "

    ^ #()! !

!ConfigurationOfA4BPonMoose methodsFor: 'symbolic versions' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 21:32'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfA4BPonMoose methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 18:52'!
project
    ^ project
        ifNil: [ 
            "Bootstrap Metacello if it is not already loaded"
            self class ensureMetacello.
            project := MetacelloMCProject new projectAttributes: self customProjectAttributes.	"Create the Metacello project"
            (Smalltalk at: #'MetacelloVersionConstructor') on: self project: project.	"Construct the project"
            project loadType: #'linear'.	"change to #atomic if desired"
            project ]! !

!ConfigurationOfA4BPonMoose methodsFor: 'symbolic versions' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 21:32'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfA4BPonMoose methodsFor: 'versions' stamp: 'AlvaroJosePeraltaOcampo 4/28/2016 22:01'!
version10: spec
	<version: '1.0' imports: #('0.1-baseline' )>
	""
	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.0'.
		spec author: 'AlvaroJosePeraltaOcampo'.
		spec timestamp: '4/28/2016 21:32'.
		spec 
			project: 'A4BP' with: '1.11';
			project: 'Moose' with: '5.1'.
		spec 
			package: 'AgentOrganizationEvaluation-A4BP' with: 'AgentOrganizationEvaluation-A4BP-SergeStinckwich.4';
			package: 'AgentOrganizationEvaluation-Model' with: 'AgentOrganizationEvaluation-Model-LeThanhUbuntu.120'. ].
! !
